const app = getApp<IAppOption>()

Component({
  options: {
    multipleSlots: true, // 在组件定义时的选项中启用多slot支持
  },
  properties: {
    title: String,
    fixed: Boolean,
    placeholder: Boolean,
    leftText: String,
    rightText: String,
    customStyle: String,
    leftArrow: Boolean,
    border: {
      type: Boolean,
      value: false,
    },
    zIndex: {
      type: Number,
      value: 1,
    },

    back: {
      type: Boolean,
      value: true,
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    imageUrl: app.globalData.imageUrl,
    Timestamp:app.globalData.Timestamp
  },

  /**
   * 组件的方法列表
   */
  methods: {
    onClickLeft() {
      if(this.data.back)
      this.triggerEvent('clickLeft', {}, {})
    },
    onClickRight() {
      this.triggerEvent('clickRight', {}, {})
    },
  },
})
