const dayjs = require('dayjs')
const app = getApp<IAppOption>()

Page({
  data: {
    list: [] as any[],
    total: 0,
    pagination: {
      page: 1,
      pages: 1,
      count: 1,
    },
  },
  onShow() {
    app.waitLogin().then(() => {
    app.mpBehavior({ PageName: 'PG_EDUCATION' })
      this.getList()
    })
  },
  getList(newPage = 1) {
    wx.ajax({
      method: 'GET',
      url: '?r=wtx/knowledge/list',
      data: {
        page: newPage,
      },
    }).then((res) => {
      res.list.forEach((item: any) => {
        item.UpdateTime = dayjs(item.UpdateTime).format('YYYY-MM-DD')
      })
      const list = res.page === 1 ? res.list : [...this.data.list, ...res.list]
      this.setData({
        total: res.count,
        list,
        pagination: {
          page: res.page,
          pages: res.pages,
          count: res.count,
        },
      })
    })
  },
  onReachBottom() {
    const { page, pages } = this.data.pagination
    if (pages > page) {
      this.getList(page + 1)
    }
  },
  handleDetail(e) {
    const { index } = e.currentTarget.dataset
    const params = this.data.list[index]
    if (params.Type == 1) {
      wx.navigateTo({
        url: `/pages/knowledgeDetail/index?id=${params.Id}`,
      })
      return
    }
    wx.navigateTo({
      url: `/pages/knowledgeDetailVideo/index?id=${params.Id}`,
    })
  },
})

export {}
