/**
 *  获取当前页面路径
 * @returns string
 */
export const getCurrentPageUrl = function () {
  const pages = getCurrentPages()
  const currentPage = pages[pages.length - 1]
  const url = `/${currentPage.route}`
  return url
}

export const parseUrlArgsToArray = (urlArgs) => {
  urlArgs = urlArgs.split('&')
  const results = {}
  urlArgs.forEach((arg) => {
    arg = arg.split('=')
    if (arg[0] && arg[1]) {
      results[arg[0]] = arg[1]
    }
  })
  return results
}
export const parseScene = (scene) => {
  if (scene) {
    return parseUrlArgsToArray(decodeURIComponent(scene))
  } else {
    return null
  }
}
