interface globalSystemInfo extends WechatMiniprogram.SystemInfo {
  capsulePosition: {
    top: number
    bottom: number
    right: number
    left: number
    width: number
    height: number
  }
}

interface pickerItem {
  id: string
  value: string
}

interface ISpecItem {
  giftId: string
  specName: string
  hysGoodsId: string
  integral: string
  unitPrice: string
  stock: string
}

type pickerList = pickerItem[]

interface IAppOption {
  globalData: {
    url?: string
    upFileUrl: string
    imageUrl: string

    Timestamp: number

    loginState: string
    isLogin: 0 | 1
    isReg: 0 | 1
    userId: string
    guestPrivacyAgree: boolean

    [propName: string]: any
  }
  getUserInfo: () => Promise<any>
  startLogin: () => void
  waitLogin: () => Promise<void>
  mpBehavior: (data: { PageName: string; type?: 0 | 1 | 2 | 3 }) => void
  globalSystemInfo?: globalSystemInfo
  [propName: string]: any
}

interface Response<T> {
  code: string
  data: T
  message: string
}

interface IAgaxParams extends WechatMiniprogram.RequestOption {
  showMsg?: boolean
  loading?: boolean
  loadingText?: string
  isJSON?: boolean
}

declare namespace WechatMiniprogram {
  export interface Wx {
    ajax: (params: IAgaxParams) => Promise<any>
  }
}
